' $Horde: HordeConduit/HordeSync/baseConduit.vb,v 1.1.1.1 2003/03/05 05:12:25 marcus Exp $
Imports PDDirectLib
Imports PDStandardLib

Public Class baseConduit
    Protected Shared HSU As HordeSyncUtility
    Protected Shared palmHotSyncUtility As New PDHotSyncUtility()
    Protected Shared palmCondMgr As New PDCondMgr()

    Protected sName As String = "Horde Base Conduit - Don't Use This Directly"
    Protected dVersion As Double = 1.0#
    Protected nDefaultAction As ESyncTypes = ESyncTypes.eFast
    Protected nMfcVersion As EMfcVersion = EMfcVersion.ePDMFC_NOT_USED


    Overridable ReadOnly Property Name() As String
        Get
            Return Me.sName
        End Get
    End Property
    Overridable ReadOnly Property Version() As Double
        Get
            Return Me.dVersion
        End Get
    End Property
    Overridable ReadOnly Property DefaultAction() As PDDirectLib.ESyncTypes
        Get
            Return Me.nDefaultAction
        End Get
    End Property
    Overridable ReadOnly Property MfcVersion() As PDDirectLib.EMfcVersion
        Get
            Return Me.nMfcVersion
        End Get
    End Property
    Overridable Sub CfgConduit(ByVal nUserId As Integer, _
                               ByVal sUserName As String, _
                               ByVal sPathName As String, _
                               ByRef nSyncPerm As Integer, _
                               ByRef nSyncTemp As Integer, _
                               ByRef nSyncNew As Integer, _
                               ByRef nSyncPref As Integer)
        Dim fSync As New frmSyncPrefs()
        fSync.grpSettings.Text = sUserName & "'s Current Settings"
        fSync.grpAction.Text = "HotSync Action for " & Me.Name

        Select Case nSyncPerm
            Case ESyncTypes.eDoNothing
                fSync.lblDefaultAction.Text = "Do nothing"
            Case ESyncTypes.eHHtoPC
                fSync.lblDefaultAction.Text = "Handheld overwrites Desktop"
            Case ESyncTypes.ePCtoHH
                fSync.lblDefaultAction.Text = "Desktop overwrites Handheld"
            Case Else
                fSync.lblDefaultAction.Text = "Synchronize the Files"
        End Select

        Select Case nSyncTemp
            Case ESyncTypes.eDoNothing
                fSync.lblNextAction.Text = "Do nothing"
                fSync.optDoNothing.Checked = True
            Case ESyncTypes.eHHtoPC
                fSync.lblNextAction.Text = "Handheld overwrites Desktop"
                fSync.optHHtoPC.Checked = True
            Case ESyncTypes.ePCtoHH
                fSync.lblNextAction.Text = "Desktop overwrites Handheld"
                fSync.optPCtoHH.Checked = True
            Case Else
                fSync.lblNextAction.Text = "Synchronize the Files"
                fSync.optSync.Checked = True
        End Select

        fSync.ShowDialog()
        If Not fSync.bCancelled Then
            If fSync.chkDefault.Checked = True Then
                nSyncPref = ESyncPref.ePermanentPreference
            End If
            If fSync.optDoNothing.Checked Then
                nSyncNew = ESyncTypes.eDoNothing
            ElseIf fSync.optHHtoPC.Checked Then
                nSyncNew = ESyncTypes.eHHtoPC
            ElseIf fSync.optPCtoHH.Checked Then
                nSyncNew = ESyncTypes.ePCtoHH
            Else
                nSyncNew = ESyncTypes.eFast
            End If
        End If
        fSync = Nothing
    End Sub
    Public Overridable Function BeginProcess() As Boolean
        Dim palmSystem As New PDSystemAdapter()
        Dim palmHotSyncInfo As PDHotsyncInfo = palmSystem.PDHotsyncInfo

        'Make sure that if HSU is defined, it matches the right user.
        If Not HSU Is Nothing Then
            Dim palmUserData As New PDUserData()
            If Not palmUserData.GetUserNameFromID(HSU.PalmUserId) = palmHotSyncInfo.UserName Then
                HSU = Nothing
            End If
        End If

        'Make sure that HSU actually is defined (might have been reset in previous block)
        If HSU Is Nothing Then
            Try
                HSU = New HordeSyncUtility(Nothing, palmHotSyncInfo.UserName)
            Catch err As SystemException
                Return False
            End Try
        End If

    End Function
    Protected Function AddCategory(ByRef palmCat As PDCategories, ByVal sName As String) As Int32
        Dim x As Integer, idx As Integer = -1, cid As Integer = 1
        If sName = "Unfiled" Then cid = 0
        For x = 0 To 15
            If palmCat.Name(x) = sName Then Return x
            If idx < 0 And palmCat.Name(x) = "" Then idx = x
        Next
        If idx < 0 Then Throw New SystemException("Categories list is full")

        palmCat.Name(idx) = sName
        palmCat.CategoryId(idx) = palmCat.LastId
        palmCat.Dirty(idx) = True
        palmCat.LastId += 1
        palmCat.Save()
        Return palmCat.CategoryId(idx)
    End Function
End Class
